# Copyright 2008 (C) Canonical Ltd.

from gettext import gettext as _

import sys

# TODO: use optparse.Optionparser!? I've used this already in my branch (blueyed)
#       See http://bazaar.launchpad.net/~blueyed/five-a-day/five-a-day-lazy-remote/revision/48
#       In general, parse_args should already validate bug arguments and some object should get
#       used to store parsed options/actions, so that other methods do not have to e.g.
#       filter "-f" and "--force" out!
# TODO: Option "-n"/"--no-remote" to never update/commit the branch

USAGE = \
_("""5-a-day --add <bug numbers>     add <bug numbers> to your 5-a-day
    -f | --force                force commit to the remote branch

5-a-day --update                update ~/.signature with the bugs you've worked on
    --html                      update ~/.signature and print HTML signature
    --yesterday                 update ~/.signature with yesterdays bugs
    
5-a-day --add-tag <tag>         tag subsequent bugs with <tag>
5-a-day --remove-tag <tag>      remove <tag> from your tag list""")

def parse_args():
    args = sys.argv
    cmd = args[0]
    
    if len(args)>1 and args[1] in ["--help", "-h"]:
        print USAGE
        sys.exit(0)
    
    a = list()
    if cmd.endswith("update-signature"):
        a.append("--update")
        if args and "--html" in args:
            a.append("--html")
        if args and "--yesterday" in args:
            a.append("--yesterday")

    if cmd.endswith("add-5-a-day"):
        a.append("--add")
        if args[1:]:
            a.extend(args[1:])
        

    if a:
        print _("Calling: 5-a-day %s") % " ".join(a)
    else:
        a = args[1:]

    if (not a) or a[0] not in ["--update", "--add", "--remove-tag", "--add-tag"]:
        print >> sys.stderr, USAGE
        sys.exit(1)

    if a[0] == "--add" and len(a) == 1: # "--add -f" is allowed
        print >> sys.stderr, USAGE
        sys.exit(1)

    if a[0] in ["--add", "--remove-tag"] and len(a) == 1:
        print >> sys.stderr, USAGE
        sys.exit(1)

    return a 
